Nodejs child processes
===

NOTE: also keep in mind things like scuttlebut and the gossip protocol

Interprocess communication ([Wikipedia](https://en.wikipedia.org/wiki/Inter-process_communication)) at the systems level is an advanced topic,[^n] but if you dive into nodejs and its child_process module ([api](https://nodejs.org/api/child_process.html)) you can quickly get the hang of some simple communication. I surveyed prior discussion on child processes but I didn't find any to be perfect.<sup><a href="#prior">prior</a></sup>


<a href="#prior">**Prior analysis**</a></br>
Trevor Norris's [child process multiple file descriptors](http://blog.trevnorris.com/2013/07/child-process-multiple-file-descriptors.html) is a short and sweet angle. Graeme Boy quickly covers it in [Node.js External and Child Processes](http://www.graemeboy.com/node-child-processes). Krasimir Tsonev's [Node.js: managing child processes](http://krasimirtsonev.com/blog/article/Nodejs-managing-child-processes-starting-stopping-exec-spawn) (2014) demonstrates how to kill child processes of a child process. Nodejitsu has only [a single simple example lacking communication](https://docs.nodejitsu.com/articles/child-processes/how-to-spawn-a-child-process) in its child process section, although it covers piping in its separate "Advanced" streams section.

[^n]: Interprocess communication beyond parent to child can be handled by a range of techniques, but message queues and sockets (of either Unix or web flavor) are popular options, and [a bunch are listed](https://github.com/joyent/node/wiki/Modules#message-queues) in node's deprecated module list. See CodePath's [Asynchronous Processing in Web Applications, Part 2: Developers Need to Understand Message Queues](http://blog.codepath.com/2013/01/06/asynchronous-processing-in-web-applications-part-2-developers-need-to-understand-message-queues/), IronMQ's [Top 10 Uses For A Message Queue](http://www.iron.io/blog/2012/12/top-10-uses-for-message-queue.html), Quora's [What are some use cases for message queues in real life?](http://www.quora.com/What-are-some-use-cases-for-message-queues-in-real-life), Stack Overflow's [Node.js — Communicating between two different processes](http://stackoverflow.com/questions/10213501/node-js-communicating-between-two-different-processes). Also check out [Tutorial: RabbitMQ + Node.js](https://www.ctl.io/developers/blog/post/tutorial-rabbitmq-node-js) and [RabbitMQ vs Redis as Message Brokers](http://www.minvolai.com/blog/2013/10/RabbitMQ-vs-Redis-as-Message-Brokers/rabbitmq-vs-redis-message-broker/). 
